//+------------------------------------------------------------------+
//|                                                     OmarGray.mq4 |
//|                                                   jlpiconsulting |
//|                                          jlpiconsulting@yahoo.fr |
//+------------------------------------------------------------------+
#property copyright "jlpiconsulting"
#property link      "jlpiconsulting@yahoo.fr"

extern string i_Trend = "Parameters for i-Trend";
extern double i_TrendThreshold = 0.001;
extern int Bandes_Mode = 0;
extern int Power_Price = 0;
extern int Price_Type = 0;
extern int Bands_Period = 20;
extern int Bands_Deviation = 2;
extern int Power_Period = 13;
extern int Count_Bars = 6000;

extern string Stochastic = "Parameters for Stochastic";
extern int StochTimeFrame = PERIOD_M30;
extern int KPeriod = 5;
extern int DPeriod = 3;
extern int Slowing = 3;
extern int MAMethod = 0;
extern int PriceField = 0;

extern string ADX = "Parameters for ADX";
extern int ADXThreshold = 25;
extern int ADXPeriod = 11;
extern int ADXPrice = 0;

extern string RSI_DEL = "Parameters for RSI_DEL";
extern int RSIPeriod1 = 14;
extern int RSIPeriod2 = 28;
extern int RSIPrice = 0;
extern int SmzPeriod = 14;
extern int SmzMode = 0;
extern int RSITimeFrame = PERIOD_M15;
extern int History = 6000;

extern string NMR20 = "Parameters for NMR20";
extern int NMRThreshold = 4;
extern int MaxBarsToCount = 1200;
extern int NMRTimeFrame = PERIOD_M15;

extern string RVI = "Parameters for RVI";
extern int RVIPeriod = 10;

extern string LSMA = "Parameters for LSMA";
extern int LSMAPeriod = 34;
extern int LSMABars = 104;
extern int LSMAHistory = 1500;

datetime bartime;

bool BuyOK = true;
bool SellOK = true;
int LastCross = 0;
datetime openbar;
int PosRSIMax = -1;
int PosRSIMin = -1;
int PosLSMax = -1;
int PosLSMin = -1;
double RSIMax = -1;
double RSIMin = -1;
double LSMax = -1;
double LSMin = -1;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
    CheckLimits();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   double iTrendGreen, iTrendRed;
   double StochGreen, StochRed;
   double RSIGreen, RSIRed;
   double LSMAGreen, LSMARed;
   double RVIMain, RVISignal;
   double RVIMainPrev, RVISignalPrev;
   double NMRRed;
   double Adx;
   string name;
   double lsma;
   double cross;
   
   if (bartime == Time[0]) {
  //       return (0);
   } else {
       CheckLimits();
      bartime = Time[0];
   }

   iTrendGreen = iCustom(Symbol(),0,"i_Trend",Bandes_Mode, Power_Price, Price_Type, Bands_Period, Bands_Deviation, Power_Period, Count_Bars, 0, 0);
   iTrendRed = iCustom(Symbol(),0,"i_Trend",Bandes_Mode, Power_Price, Price_Type, Bands_Period, Bands_Deviation, Power_Period, Count_Bars, 1, 0);
   StochGreen = iCustom(Symbol(),0,"#MTF_Stochastic",StochTimeFrame, KPeriod, DPeriod, Slowing, MAMethod, PriceField, 0, 0);
   StochRed = iCustom(Symbol(),0,"#MTF_Stochastic",StochTimeFrame, KPeriod, DPeriod, Slowing, MAMethod, PriceField, 1, 0);
   Adx = iADX(Symbol(),0, ADXPeriod, ADXPrice, 0, 0);
   RSIGreen = iCustom(Symbol(),RSITimeFrame,"RSI_Del_WA_mtf", RSIPeriod1, RSIPeriod2, RSIPrice, SmzPeriod, SmzMode, RSITimeFrame, "", "", History, 0, 0);
   RSIRed = iCustom(Symbol(),RSITimeFrame,"RSI_Del_WA_mtf", RSIPeriod1, RSIPeriod2, RSIPrice, SmzPeriod, SmzMode, RSITimeFrame, "", "", History, 1, 0);
   LSMAGreen = iCustom(Symbol(),0,"LSMA", LSMAPeriod, LSMAHistory, 1, 0);
   LSMARed = iCustom(Symbol(),0,"LSMA",  LSMAPeriod, LSMAHistory, 2, 0);
   NMRRed = iCustom(Symbol(),NMRTimeFrame,"NMR20_mtf", MaxBarsToCount, NMRTimeFrame, "", 0, 0);
   RVIMain = iRVI(Symbol(),0,RVIPeriod,MODE_MAIN,0);
   RVISignal = iRVI(Symbol(),0,RVIPeriod,MODE_SIGNAL,0);
   RVIMainPrev = iRVI(Symbol(),0,RVIPeriod,MODE_MAIN,1);
   RVISignalPrev = iRVI(Symbol(),0,RVIPeriod,MODE_SIGNAL,1);
   cross = RVIMain + (RVIMain-RVIMainPrev)*(RVIMainPrev-RVISignalPrev)/(RVIMainPrev+RVISignal-RVIMain-RVISignalPrev);
   
    if (LSMAGreen != EMPTY_VALUE && LSMAGreen != CLR_NONE)
      lsma = ConvertLSMA(LSMAGreen);
    else if (LSMARed != EMPTY_VALUE && LSMARed != CLR_NONE)
      lsma = ConvertLSMA(LSMARed); 
   
 //  Print("iTrendGreen="+iTrendGreen+" iTrendRed="+iTrendRed+" StochGreen="+StochGreen+" StochRed="+StochRed+" Adx="+Adx+" RSIGreen="+RSIGreen+" RSIRed="+RSIRed+" NMRRed="+NMRRed+" BuyOK="+BuyOK+" SellOK="+SellOK);
 //  Print("lsma="+lsma+" LSMARed="+LSMARed+" LSMAGreen="+LSMAGreen+" RVIMain="+RVIMain+" RVISignal="+RVISignal);
 //  Print("LSMin="+LSMin+" LSMax="+LSMax+" RSIMax="+RSIMax+" RSIMin="+RSIMin);
   if (RVIMain > RVISignal && RVIMainPrev < RVISignalPrev && cross > 0 && openbar != Time[0])
   {
      SellOK = true;
      Print("Sell initialized");
   }
   if (RVIMain < RVISignal && RVIMainPrev > RVISignalPrev && cross < 0 && openbar != Time[0])
   {
      BuyOK = true;
      Print("Buy initialized");
   }

   if (BuyOK && iTrendGreen > i_TrendThreshold && StochGreen > StochRed && Adx > ADXThreshold && RSIRed > RSIGreen && NMRRed > NMRThreshold && RVIMain > RVISignal && LSMAGreen != EMPTY_VALUE && LSMAGreen != CLR_NONE && RSIRed > lsma)
   {
      name = Time[0];
      Alert(Symbol()+" Alert Buy");
      ObjectCreate(name, OBJ_ARROW, 0, Time[0], Bid - 10*Point);
      ObjectSet(name, OBJPROP_ARROWCODE, SYMBOL_ARROWUP);
      PlaySound("alert.wav");
      SendMail("Mail from your EA: Alert Buy", "Alert Buy on "+Symbol());
      Print(" Alert Buy");
      BuyOK = false;
      openbar = Time[0];
   }
   
   if (SellOK && iTrendRed > i_TrendThreshold && StochRed > StochGreen && Adx > ADXThreshold && RSIGreen > RSIRed && NMRRed < -NMRThreshold && RVIMain < RVISignal && LSMARed != EMPTY_VALUE && LSMARed != CLR_NONE && RSIRed < lsma)
   {
      name = Time[0];
      Alert(Symbol()+" Alert Sell");
      ObjectCreate(name, OBJ_ARROW, 0, Time[0], Ask + 10*Point);
      ObjectSet(name, OBJPROP_ARROWCODE, SYMBOL_ARROWDOWN);
      PlaySound("alert.wav");
      SendMail("Mail from your EA: Alert Sell", "Alert Sell on "+Symbol());
      Print(" Alert Sell");
      SellOK = false;
      openbar = Time[0];
   }
   

//----
   return(0);
  }
//+------------------------------------------------------------------+

void CheckLimits()
{
   double RSIRed;
   double LSMAGreen, LSMARed;
   int i;

///////////1
   PosRSIMax++;
   if (PosRSIMax == 0 || PosRSIMax >= LSMABars)
   {
      RSIMax = -1000;
      for (i=0; i<LSMABars; i++)
      {
         RSIRed = iCustom(Symbol(),RSITimeFrame,"RSI_Del_WA_mtf", RSIPeriod1, RSIPeriod2, RSIPrice, SmzPeriod, SmzMode, RSITimeFrame, "", "", History, 1, i);
       if (RSIRed > RSIMax) 
       {    
          PosRSIMax = i;
          RSIMax = RSIRed;
       }
     }
   }
   else
   {
      RSIRed = iCustom(Symbol(),RSITimeFrame,"RSI_Del_WA_mtf", RSIPeriod1, RSIPeriod2, RSIPrice, SmzPeriod, SmzMode, RSITimeFrame, "", "", History, 1, 0);
      if (RSIRed > RSIMax) 
      {    
         PosRSIMax = 0;
         RSIMax = RSIRed;
      }
   }
 
///////////2
   PosRSIMin++;
   if (PosRSIMin == 0 || PosRSIMin >= LSMABars)
   {
      RSIMin = 1000;
      for (i=0; i<LSMABars; i++)
      {
         RSIRed = iCustom(Symbol(),RSITimeFrame,"RSI_Del_WA_mtf", RSIPeriod1, RSIPeriod2, RSIPrice, SmzPeriod, SmzMode, RSITimeFrame, "", "", History, 1, i);
       if (RSIRed < RSIMin) 
       {    
          PosRSIMin = i;
          RSIMin = RSIRed;
       }
     }
   }
   else
   {
      RSIRed = iCustom(Symbol(),RSITimeFrame,"RSI_Del_WA_mtf", RSIPeriod1, RSIPeriod2, RSIPrice, SmzPeriod, SmzMode, RSITimeFrame, "", "", History, 1, 0);
      if (RSIRed < RSIMin) 
      {    
         PosRSIMin = 0;
         RSIMin = RSIRed;
      }
   }
 
 
///////////3
   PosLSMax++;
   if (PosLSMax == 0 || PosLSMax >= LSMABars)
   {
      LSMax = -1000;
      for (i=0; i<LSMABars; i++)
      {
         LSMAGreen = iCustom(Symbol(),0,"LSMA", LSMAPeriod, LSMAHistory, 1, i);
         if (LSMAGreen > LSMax && LSMAGreen != EMPTY_VALUE && LSMAGreen != CLR_NONE) 
         {    
            PosLSMax = i;
            LSMax = LSMAGreen;
         }
     }
   }
   else
   {
      LSMAGreen = iCustom(Symbol(),0,"LSMA", LSMAPeriod, LSMAHistory, 1, 0);
      if (LSMAGreen > LSMax && LSMAGreen != EMPTY_VALUE && LSMAGreen != CLR_NONE) 
      {    
         PosLSMax = 0;
         LSMax = LSMAGreen;
      }
   }
 
///////////4
   PosLSMin++;
   if (PosLSMin == 0 || PosLSMin >= LSMABars)
   {
      LSMin = 1000;
      for (i=0; i<LSMABars; i++)
      {
         LSMARed = iCustom(Symbol(),0,"LSMA",  LSMAPeriod, LSMAHistory, 2, i);
         if (LSMARed < LSMin && LSMARed != EMPTY_VALUE && LSMARed != CLR_NONE) 
         {    
            PosLSMin = i;
            LSMin = LSMARed;
         }
     }
   }
   else
   {
      LSMARed = iCustom(Symbol(),0,"LSMA",  LSMAPeriod, LSMAHistory, 2, 0);
      if (LSMARed < LSMin && LSMARed != EMPTY_VALUE && LSMARed != CLR_NONE) 
      {    
         PosLSMin = 0;
         LSMin = LSMARed;
      }
   }
   
}

double ConvertLSMA(double lsma)
{
   return(((lsma-LSMin)*(RSIMax-RSIMin)/(LSMax-LSMin))+RSIMin);
}